#include <stdio.h>
#include <system_def.h>
#include <ul_lib/ulan.h>
#include <hal_intr.h>
#include "u2u_vend.h"

extern char ulan_configured;
extern ul_fd_t ul_fd_rx,ul_fd_tx;

int usb_u2u_vendor(usb_device_t *udev)
{
  int my_adr;
  my_adr=(udev->request.wIndex & 0x3F);
  switch ( udev->request.bRequest) {
    case VENDOR_START_ULAN:
      ulan_configured=0;
      switch (udev->request.wValue) {
        case 9600:
          ulan_configured=1;
          ul_setmyadr(ul_fd_rx,my_adr);
          ul_setbaudrate(ul_fd_rx,9600);
          break;
        case 19200:
          ulan_configured=1;
          ul_setmyadr(ul_fd_rx,my_adr);
          ul_setbaudrate(ul_fd_rx,19200);
          break;
        case 38400:
          ulan_configured=1;
          ul_setmyadr(ul_fd_rx,my_adr);
          ul_setbaudrate(ul_fd_rx,38400);
          break;
        case 56800:
          ulan_configured=1;
          ul_setmyadr(ul_fd_rx,my_adr);
          ul_setbaudrate(ul_fd_rx,56800);
          break;
      }
      if (ulan_configured) HAL_INTERRUPT_UNMASK(UL_DRV_SYSLESS_IRQ);
      else HAL_INTERRUPT_MASK(UL_DRV_SYSLESS_IRQ);
      usb_send_control_data(udev,&ulan_configured,1);
      return 1;
    case VENDOR_STOP_ULAN:
      ulan_configured=0;
      HAL_INTERRUPT_MASK(UL_DRV_SYSLESS_IRQ);
      return 1;
    case VENDOR_IS_RUNNING_ULAN:
      return ulan_configured;
  }

  return 0;
}
