#include <cpu_def.h>
#include "ul_drv_fnc.h"

#ifdef SDCC
#ifndef SDCC_MODEL_LARGE
data uchar ul_dy_len;
#endif /* SDCC_MODEL_LARGE */
#endif /* SDCC */

#ifdef SDCC
unsigned long ul_drv_get_sn() 
{
  _asm
	mov  dptr,#ser_num
	movx a,@dptr
	mov  r2,a
	inc  dptr
	movx a,@dptr
	mov  r3,a
	inc  dptr
	movx a,@dptr
	mov  b,a
	inc  dptr
	movx a,@dptr
	mov  dpl,r2
	mov  dph,r3
  _endasm;
}
#else
#error "unsuported compiler!"
#endif

#ifdef SDCC
void ul_drv_set_sn(unsigned long sn) 
{
  _asm
	mov  r2,a
	mov  r3,dpl
	mov  r4,dph
	mov  dptr,#ser_num
	mov  a,r3
	movx @dptr,a
	inc  dptr
	mov  a,r4
	movx @dptr,a
	inc  dptr
	mov  a,b
	movx @dptr,a
	inc  dptr
	mov  a,r2
	movx @dptr,a
  _endasm;
}
#else
#error "unsuported compiler!"
#endif


#ifdef SDCC
ul_idstr_t *ul_drv_get_idstr() 
{
  _asm
	mov  dptr,#_ul_idstr
	mov  b,#0x80
  _endasm;
}
#else
#error "unsuported compiler!"
#endif

#ifdef SDCC
unsigned char ul_drv_get_adr()
{
  _asm
	mov  dptr,#ul_adr
	movx a,@dptr
	mov  dpl,a
  _endasm;
}
#else
#error "unsuported compiler!"
#endif

#ifdef SDCC
unsigned char ul_drv_get_dysa()
{
  _asm
	mov  dptr,#ud_dysa
	movx a,@dptr
	mov  dpl,a
  _endasm;
}
#else
#error "unsuported compiler!"
#endif

#ifdef SDCC
char ul_drv_rqa() UL_FNC_NAKED
{ 
  _asm
	.globl ul_t_rqa
	lcall ul_t_rqa
	mov   dpl,a
    #ifdef UL_WITH_NAKED
	ret
    #endif /*UL_WITH_NAKED*/
  _endasm;
}
#else
#error "unsuported compiler!"
#endif

#ifdef SDCC
void ul_drv_clr_rq() 
{ 
  _asm
	mov  a,ul_fld
	anl  a,#0xF8
	mov  ul_fld,a
  _endasm;
}
#else
#error "unsuported compiler!"
#endif

#ifdef SDCC
#ifndef SDCC_MODEL_LARGE
void ul_drv_set_status(uchar UL_ARGPTRTYPE *status,uchar len) 
{
  ul_dy_len=len;
  _asm
	mov  r2,dpl
	mov  r3,dph
	mov  dptr,#ud_stad
	mov  a,r2
	movx @dptr,a
	inc  dptr
	mov  a,r3
	movx @dptr,a
	inc  dptr
	mov  a,_ul_dy_len
	movx @dptr,a   
  _endasm;
}
#else
void ul_drv_set_status(uchar UL_ARGPTRTYPE *status,uchar len) UL_FNC_REENTRANT UL_FNC_NAKED
{
  _asm
	mov  a,sp
    #ifdef UL_WITH_NAKED
	add  a,#-3
    #else /*UL_WITH_NAKED*/
	add  a,#-4
    #endif /*UL_WITH_NAKED*/
	mov  r0,a
	mov  a,@r0
	mov  r4,a
	mov  r2,dpl
	mov  r3,dph
	mov  dptr,#ud_stad
	mov  a,r2
	movx @dptr,a
	inc  dptr
	mov  a,r3
	movx @dptr,a
	inc  dptr
	mov  a,r4
	movx @dptr,a
    #ifdef UL_WITH_NAKED
	ret
    #endif /*UL_WITH_NAKED*/
  _endasm;
}
#endif /* SDCC_MODEL_LARGE */
#else
#error "unsuported compiler!"
#endif
