#ifndef _ULOI_BASE_H
#define _ULOI_BASE_H

#include <stdlib.h>
#include <ul_lib/ulan.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef UL_ARGPTRTYPE
#define UL_ARGPTRTYPE
#endif

#ifndef NULL_FNC
#ifndef SDCC
  #define ULOI_CODE
  #define NULL_CODE NULL
#else /*SDCC*/
  #define ULOI_CODE code
  #define NULL_CODE (0)
#endif /*SDCC*/
#endif /*NULL_FNC*/

#ifndef ULOI_GENOBJIDTAG
  #ifdef CONFIG_ULOI_GENOBJIDTAG
    #define ULOI_GENOBJIDTAG(_name,_oid) \
      void uloid_objidtag_note_##_name () __attribute__ ((alias (#_oid)));
      /*__NUM2ASM(uloid_objidtag_##_name,_oid)*/
  #endif /*CONFIG_ULOI_GENOBJIDTAG*/
#endif /*ULOI_GENOBJIDTAG*/

#ifndef ULOI_GENOBJIDTAG
  #define ULOI_GENOBJIDTAG(_name,_oid)
#endif /*ULOI_GENOBJIDTAG*/


#define ULOI_TMBUF_LEN 30

#ifdef UL_WITHOUT_HANDLE
  #define ULOI_ARG_coninfo
  #define ULOI_ARG1_coninfo
  #define ULOI_PARAM_coninfo
  #define ULOI_PARAM1_coninfo
  #define coninfo (&uloi_coninfo_global)
  extern uloi_coninfo_t uloi_coninfo_global;
  extern UL_ARGPTRTYPE uchar uloi_tmpbuf[ULOI_TMBUF_LEN];
#else  /*UL_WITHOUT_HANDLE*/
  #define ul_ssize_t ssize_t
  #define ULOI_ARG_coninfo coninfo,
  #define ULOI_ARG1_coninfo coninfo
  #define ULOI_PARAM_coninfo uloi_coninfo_t *coninfo,
  #define ULOI_PARAM1_coninfo uloi_coninfo_t *coninfo
#endif /*UL_WITHOUT_HANDLE*/

#define ULOI_CONINFO_OUTOPEN 1

typedef unsigned uloi_oid_t;

typedef struct uloi_objdes_t {
  uloi_oid_t oid;
  const ULOI_CODE void *aoid;
  int (*rdfnc)(ULOI_PARAM_coninfo void *context);
  void *rdcontext;
  int (*wrfnc)(ULOI_PARAM_coninfo void *context);
  void *wrcontext;
} uloi_objdes_t;

#define ULOI_GENAOID2(_name,_type) \
  const ULOI_CODE struct {char len_all; \
          char len_name; \
	  char val_name[sizeof(#_name)-1]; \
          char len_type; \
	  char val_type[sizeof(_type)-1]; \
  } uloi_aoid_##_name={ \
    sizeof(#_name)+sizeof(_type), \
    sizeof(#_name)-1, \
    #_name, \
    sizeof(_type)-1, \
    _type \
  };

#define ULOI_GENOBJDES_RAW(_oid,_aoid,_rdfnc,_rdcontext,_wrfnc,_wrcontext) \
{ \
  _oid, \
  _aoid, \
  _rdfnc, \
  _rdcontext, \
  _wrfnc, \
  _wrcontext \
};

#define ULOI_GENOBJDES(_name,_oid,_type,_rdfnc,_rdcontext,_wrfnc,_wrcontext) \
ULOI_GENAOID2(_name,_type) \
const ULOI_CODE uloi_objdes_t uloid_objdes_##_name = \
ULOI_GENOBJDES_RAW(_oid,&uloi_aoid_##_name,_rdfnc,_rdcontext,_wrfnc,_wrcontext) \
ULOI_GENOBJIDTAG(_name,_oid)

#define ULOI_GENOBJDES_STD(_name,_oid,_type,_rdfnc,_rdcontext,_wrfnc,_wrcontext) \


typedef struct uloi_objdes_array_t {
  /*gsa_array_field_t;*/
  struct {
    uloi_objdes_t **items;
    unsigned count;
    unsigned alloc_count;
  } array;
} uloi_objdes_array_t;


uloi_objdes_t *
uloi_objdes_array_at (const uloi_objdes_array_t * array, unsigned indx);

uloi_objdes_t *
uloi_objdes_array_find (const uloi_objdes_array_t * array, uloi_oid_t * key);

unsigned
uloi_objdes_array_find_indx (const uloi_objdes_array_t * array,
				   uloi_oid_t * key);

unsigned
uloi_objdes_array_find_after_indx (const uloi_objdes_array_t * array,
				   uloi_oid_t * key);


int uloi_i_open(ULOI_PARAM_coninfo UL_ARGPTRTYPE ul_msginfo *imsginfo);
int uloi_o_open(ULOI_PARAM1_coninfo);
int uloi_i_close(ULOI_PARAM1_coninfo);
int uloi_o_close(ULOI_PARAM1_coninfo);
ul_ssize_t uloi_i_read(ULOI_PARAM_coninfo void *buffer, size_t size);
ul_ssize_t uloi_o_write(ULOI_PARAM_coninfo const void *buffer, size_t size);

int uloi_process_msg(ULOI_PARAM_coninfo uloi_objdes_array_t *objdes_array, UL_ARGPTRTYPE ul_msginfo *imsginfo);

int uloi_doii_fnc(ULOI_PARAM_coninfo void *context);
int uloi_doio_fnc(ULOI_PARAM_coninfo void *context);
int uloi_qoii_fnc(ULOI_PARAM_coninfo void *context);
int uloi_qoio_fnc(ULOI_PARAM_coninfo void *context);
int uloi_rdrq_fnc(ULOI_PARAM_coninfo void *context);

int uloi_char_rdfnc(ULOI_PARAM_coninfo void *context);
int uloi_char_wrfnc(ULOI_PARAM_coninfo void *context);
int uloi_uchar_rdfnc(ULOI_PARAM_coninfo void *context);
int uloi_uchar_wrfnc(ULOI_PARAM_coninfo void *context);
int uloi_int_rdfnc(ULOI_PARAM_coninfo void *context);
int uloi_int_wrfnc(ULOI_PARAM_coninfo void *context);
int uloi_uint_rdfnc(ULOI_PARAM_coninfo void *context);
int uloi_uint_wrfnc(ULOI_PARAM_coninfo void *context);
int uloi_long_rdfnc(ULOI_PARAM_coninfo void *context);
int uloi_long_wrfnc(ULOI_PARAM_coninfo void *context);
int uloi_ulong_rdfnc(ULOI_PARAM_coninfo void *context);
int uloi_ulong_wrfnc(ULOI_PARAM_coninfo void *context);

#ifdef __cplusplus
} /* extern "C"*/
#endif

#endif /*_ULOI_BASE_H*/
