#include <uloi_base.h>

int uloi_i_open(ULOI_PARAM_coninfo UL_ARGPTRTYPE ul_msginfo *imsginfo)
{
 #ifndef UL_WITHOUT_HANDLE
  uchar uloi_tmpbuf[3];
  ul_msginfo msginfo;
 #endif
  ul_ssize_t ret;

  if(coninfo->error)
    return -1;

  if(!imsginfo){
    ret=ul_acceptmsg(coninfo->ul_fd, &msginfo);
    if(ret<0){
      coninfo->error=1;
      return -1;
    }
    if((msginfo.cmd!=coninfo->cmd)||
       (msginfo.len<3)||
       (msginfo.flg&UL_BFL_FAIL))
      goto conerr;
    coninfo->adr=msginfo.sadr;
  }else{
    if((imsginfo->cmd!=coninfo->cmd)||
       (imsginfo->len<3)||
       (imsginfo->flg&UL_BFL_FAIL))
      goto conerr1;
    coninfo->adr=imsginfo->sadr;
    ret=1;
  }

  if(uloi_i_read(ULOI_ARG_coninfo uloi_tmpbuf, 3)!=3)
    goto conerr;

  coninfo->bcmd=uloi_tmpbuf[0];
  coninfo->bsn=uloi_tmpbuf[1];
  /* We could need our loop-back serial number for messages tracking */
  coninfo->sn=uloi_tmpbuf[2];

  return ret;

  conerr:
   #ifdef ul_i_close
    ul_i_close(coninfo->ul_fd);
   #else
    ul_abortmsg(coninfo->ul_fd);
   #endif
  conerr1:
    if(!coninfo->error)
      coninfo->error=1;
    return -1;
}

int uloi_o_open(ULOI_PARAM1_coninfo)
{
 #ifndef UL_WITHOUT_HANDLE
  ul_msginfo msginfo;
  uchar uloi_tmpbuf[3];
 #endif
  ul_ssize_t ret;

  if(coninfo->state&ULOI_CONINFO_OUTOPEN)
    return 0;

  msginfo.dadr=coninfo->adr;
  msginfo.sadr=0;
  msginfo.cmd=coninfo->bcmd;
  msginfo.flg=UL_BFL_SND|UL_BFL_ARQ;
  msginfo.len=0;
  ret=ul_newmsg(coninfo->ul_fd1, &msginfo);
  if(ret<0){
    coninfo->error=1;
    uloi_i_close(ULOI_ARG1_coninfo);
    return -1;
  }

  uloi_tmpbuf[0]=coninfo->cmd;
  /* We do not run own sequence numbers in the device */
  uloi_tmpbuf[1]=0; /*coninfo->sn;*/
  uloi_tmpbuf[2]=coninfo->bsn;

  if(uloi_o_write(ULOI_ARG_coninfo uloi_tmpbuf, 3)!=3){
    coninfo->error=1;
    uloi_o_close(ULOI_ARG1_coninfo);
    return -1;
  }

  coninfo->state|=ULOI_CONINFO_OUTOPEN;

  return 1;
}

int uloi_i_close(ULOI_PARAM1_coninfo)
{
#ifdef ul_i_close
  return ul_i_close(coninfo->ul_fd);
#else
  if(coninfo->error){
    return ul_abortmsg(coninfo->ul_fd);
  }
  return ul_freemsg(coninfo->ul_fd);
#endif
}

int uloi_o_close(ULOI_PARAM1_coninfo)
{
  if(!(coninfo->state&ULOI_CONINFO_OUTOPEN))
    return 0;

  coninfo->state&=~ULOI_CONINFO_OUTOPEN;

#ifdef ul_o_close
  if(coninfo->error)
    return -1;
  return ul_o_close(coninfo->ul_fd1);
#else
  if(coninfo->error){
    return ul_abortmsg(coninfo->ul_fd1);
  }
  return ul_freemsg(coninfo->ul_fd1);
#endif
}

ul_ssize_t uloi_i_read(ULOI_PARAM_coninfo void *buffer, size_t size)
{
  ul_ssize_t ret;
  if(coninfo->error)
    return -1;
  ret=ul_read(coninfo->ul_fd, buffer, size);
  if(ret<0)
    coninfo->error=1;
  return ret;
}

ul_ssize_t uloi_o_write(ULOI_PARAM_coninfo const void *buffer, size_t size)
{
  ul_ssize_t ret;
  if(coninfo->error)
    return -1;
  ret=ul_write(coninfo->ul_fd1, buffer, size);
  if(ret<0)
    coninfo->error=1;
  return ret;
}
